enum guideMethod {RANDOM, SIG, FIELD};
struct globals {

  int            popSize;
  int            REPSize;
  int            maxCycles;
  unsigned int   popSeed;
  unsigned int   dataSeed;
  int            noObjectives;
  double   	 mut;
  guideMethod    findguide;
  
};

class test {  

  static int  cmpItems(const void*  itemPtr1, const void*  itemPtr2);

 public:
  int       noParameters;
  int       noObjectives;
  test(int noobjective, int noparameters);
};

class individual {

  static test*      testPtr;
  double*           objectives;
  double*           x_ind;
  double*           v_ind;
  
  short             objValid;
  double            fitness;
  short             fitValid;

 public:
  individual(void);
  ~individual(void);
  
  static void    Reset(test*  testData);
  double         GetObjective(int  no);
  double  	 GetVelocity(int j);
  double	 GetPosition(int j);
  void  	 SetVelocity(double vel, int j);
  void  	 SetPosition(double x, int j);

  int            Dominates(individual&  ind, int  noConsideredObjectives);
  int            Dominates(individual&  ind);
  int            Equals(individual&  ind);
  friend void    CopyIndividual(individual&  indSrc, individual&  indDest);
  friend void    PrintIndividual(individual&  ind);
  friend double      IndDistance(individual&  ind1, individual&  ind2);
};

typedef individual*  individualPtr;

class population {
  individualPtr*    tempArray;  // used for finding Pareto points and sorting
  int*              selectedSolutions; //
  int*              clusters;          //
  int*              clusterList;       // needed for clustering
  
  double      ClusterDistance(int  cluster1, int  cluster2);
  void        JoinClusters(int  cluster1, int  cluster2, int&  numOfClusters);
  int         ClusterCentroid(int  cluster);
  
  static test*  testPtr;
  static int  CmpInds(const void*  indPtr1, const void*  indPtr2);

 public:
  int          size;     // number of actually occupied entries
  int          maxSize;  // number of allocated entries
  individual*  indArray;
  individual*  TempParetoSet;
  individual*  pbest;
  population(int  popSize, test*  testData);
  ~population(void);
  
  void         ReduceByClustering(int  reducedSize);
  void         GetREP(population*  REP);
  void	       Update(population*  REP, globals&  params); 
  void	       Evaluate(void);
  void         Print(ostream&  out);
  friend void  CopyPopulation(population&  popSrc, population&  popDest);
};




